\documentclass{standalone}

\input{../../macros/macros}

\usepackage{../../../msc}

\begin{document}

\begin{msc}[msc keyword=, draw frame = none, instance distance=4cm]{}
\declinst{V}{}{V}
\declinst{P}{}{P}
\action*{nonce $\nonce{0V}$}{V}
\action*{nonce $\nonce{0P}$}{P}
\nextlevel[1.5]
\action*{nonce $\nonce{1V}$}{V}
\action*{nonce $\nonce{1P}$}{P}
\nextlevel[1.5]
\action*{nonce ${x_V}$}{V}
\action*{nonce ${x_P}$}{P}
\nextlevel[3]
\mess{$h(0, \nonce{0V}, \nonce{1V}, g^{x_V})$}{V}{P}
\nextlevel[2]
\mess{$h(1, \nonce{0P}, \nonce{1P}, g^{x_P})$}{P}{V}
\nextlevel[2]
\mess*{$\nonce{0V}$}{V}{P}
\measure{max $\Delta$}{V}{V}[2]
\nextlevel[2]
\mess*{$\nonce{0V} \oplus \nonce{0P}$}{P}{V}
\nextlevel[2]
\mess*{$\nonce{1P}$}{P}{V}
\measure[r]{max $\Delta$}{P}{P}[2]
\nextlevel[2]
\mess*{$\nonce{1V} \oplus \nonce{1P}$}{V}{P}
\nextlevel[2]
\mess{$g^{x_V}$}{V}{P}
\nextlevel[2]
\mess{$g^{x_P}$}{P}{V}
\nextlevel[1]
\action*{$k = g^{x_P \cdot x_V}$}{V}
\action*{$k = g^{x_V \cdot x_P}$}{P}
\nextlevel[2]
\mess{$\enc{\pair{N_{0V}}{N_{1P}}}{k}$}{V}{P}
\nextlevel[1]
\condition*{$k$ is secret}{V}
\condition*{$k$ is secret}{P}
\nextlevel[2]
\condition*{$V$ is communicating with $P$}{V}
\condition*{$P$ is communicating with $V$}{P}
\nextlevel
\end{msc}

\end{document}